# -*- coding: cp1251 -*-
from math import gcd
def find_direction(x, y):
    g = gcd(x, y)
    x //= g
    y //= g

    p1, q1 = 0, 1
    p2, q2 = 1, 0
    path = "R"

    while True:
        p, q = p1 + p2, q1 + q2
        if p == x and q == y:
            break
        if x * q < p * y:
            path += "L"
            p2, q2 = p, q
        else:
            path += "R"
            p1, q1 = p, q

    return path

a, b = map(int, input().split())
print(find_direction(a, b))