from collections import defaultdict, deque

n,m,k=map(int,input().split())
graph=defaultdict(list)

for i in range(m):
    u,v=map(int,input().split())
    graph[u].append(v)
    graph[v].append(u)

guards=[tuple(map(int,input().split()))for _ in range(k)]
g=set()

for pos,stamina in guards:
    visited=set()
    q=deque([(pos, 0)])
    visited.add(pos)

    while q:
        current, distance = q.popleft()
        if distance > stamina:
            continue
        g.add(current)
        for neighbor in graph[current]:
            if neighbor not in visited:
                visited.add(neighbor)
                q.append((neighbor, distance + 1))

g = sorted(g)
print(len(g))
if g:
    print(" ".join(map(str, g)))